//
//  EMBAnnotationEmberObfuscation.h
//  EmberCommon
//
//  Created by Damien DeVille on 11/29/13.
//  Copyright (c) 2013 Realmac Software. All rights reserved.
//

#import "EMBEmberAnnotations/EMBAnnotationEmber.h"

@interface EMBAnnotationEmberObfuscation : EMBAnnotationEmber

/*!
	\brief
	Create a text annotation.
	
	\param orientation
	The orientation of the annotation.
	
	\param position
	The position of the annotation in the root layer coordinate system.
	
	\param text
	The text to display in the annotation.
	
	\param boxSize
	The size of the text box.
	
	\param intensity
	The intensity of the obfuscation filter. Pass 0.0 to use the default intensity.
 */
- (id)initWithOrientation:(EMBEmberAnnotationOrientation)orientation position:(CGPoint)position boxSize:(CGSize)boxSize intensity:(CGFloat)intensity;

/*!
	\brief
	The size of the box containing the text.
 */
@property (assign, nonatomic) CGSize boxSize;
extern NSString * const EMBAnnotationEmberObfuscationBoxSizeKey;

@end

extern CGFloat EMBAnnotationEmberObfuscationAppropriateIntensityForBoxSize(CGSize boxSize);
