//
//  EMBAnnotationEmberPath.h
//  EmberCommon
//
//  Created by Damien DeVille on 03/04/2013.
//  Copyright (c) 2013 Realmac Software. All rights reserved.
//

#import "EMBEmberAnnotations/EMBAnnotationEmber.h"

@interface EMBAnnotationEmberPath : EMBAnnotationEmber

/*!
	\brief
	Create a path annotation.
	
	\param orientation
	The orientation of the annotation.
	
	\param position
	The position of the annotation in the root layer coordinate system.
	
	\param path
	The path. The origin of the its bounding box needs to be {0.0, 0.0}.
 */
- (id)initWithOrientation:(EMBEmberAnnotationOrientation)orientation position:(CGPoint)position path:(CGPathRef CF_CONSUMED)path;

/*!
	\brief
	The path is in the coordinate system of the annotation.
 */
- (CGPathRef)path;

@end
