//
//  EMBEmberAnnotations-Functions.h
//  EmberCommon
//
//  Created by Damien DeVille on 3/17/13.
//  Copyright (c) 2013 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <QuartzCore/QuartzCore.h>

#import "EMBEmberHelpers/EMBEmberHelpers.h"
#import "EMBEmberAnnotations/EMBEmberAnnotations-Constants.h"

@class EMBAnnotation, EMBAnnotationLittleSnapper;

extern EMBPortableColor *EMBEmberAnnotationGetColor(EMBEmberAnnotationColor color);

extern CGFloat EMBEmberAnnotationGetLineWidth(EMBEmberAnnotationLineWidth lineWidth);
extern CGFloat EMBEmberAnnotationGetTextSize(EMBEmberAnnotationLineWidth lineWidth);

extern CGFloat EMBEmberAnnotationGetAngle(EMBEmberAnnotationOrientation orientation, BOOL flipped);
extern EMBEmberAnnotationOrientation EMBEmberAnnotationRotateClockwise(EMBEmberAnnotationOrientation orientation);
extern EMBEmberAnnotationOrientation EMBEmberAnnotationRotateAntiClockwise(EMBEmberAnnotationOrientation orientation);

/*
	Paths
*/
extern CGFloat EMBAnnotationGetPathLength(CGPathRef path);
extern CGPoint EMBAnnotationGetPathStartPoint(CGPathRef path);
extern CGPathRef EMBAnnotationCreateTrimmedPathWithLength(CGPathRef path, CGFloat length);
extern CGPathRef EMBAnnotationCreateReversedPath(CGPathRef path);
extern CGPathRef EMBAnnotationCreateTranslatedPath(CGPathRef path, CGSize translation);
extern void EMBAnnotationMutablePathAppendPath(CGMutablePathRef mutablePath, CGPathRef path, BOOL skipFirstMove);
