//
//  EMBAutoImportLocation.h
//  EmberMac
//
//  Created by Damien DeVille on 1/16/14.
//  Copyright (c) 2014 Realmac Software. All rights reserved.
//

#import <CoreData/CoreData.h>

extern NSString * const EMBAutoImportLocationEntityName;

@class EMBAutoImportFile;

@interface EMBAutoImportLocation : NSManagedObject

+ (instancetype)createWithEditingLocation:(NSURL *)location processingBookmark:(NSData *)processingBookmark managedObjectContext:(NSManagedObjectContext *)managedObjectContext;

@property (readonly, strong, nonatomic) NSURL *processingLocation;
extern NSString * const EMBAutoImportLocationProcessingLocationKey;

@property (readonly, strong, nonatomic) NSURL *editingLocation;
extern NSString * const EMBAutoImportLocationEditingLocationKey;

@property (strong, nonatomic) NSString *name;
extern NSString * const EMBAutoImportLocationNameKey;

@property (strong, nonatomic) NSNumber *trash;
extern NSString * const EMBAutoImportLocationTrashKey;

@property (strong, nonatomic) NSString *tags;
extern NSString * const EMBAutoImportLocationTagsKey;

@property (strong, nonatomic) NSSet *files;
extern NSString * const EMBAutoImportLocationFilesKey;

extern NSString * const EMBAutoImportLocationPredicateKey;
@property (strong, nonatomic) NSPredicate *predicate;

@property (readonly, strong, nonatomic) NSPredicate *processingPredicate;

@end

extern NSString * const EMBAutoImportLocationPredicateNameKey;
extern NSString * const EMBAutoImportLocationPredicateExtensionKey;
