//
//  EMBPersistentStoreNotification.h
//  Ember
//
//  Created by Damien DeVille on 05/07/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <CoreData/CoreData.h>

@interface EMBPersistentStoreNotification : NSObject <NSSecureCoding>

@property (readonly, strong, nonatomic) NSDictionary *userInfo;

@property (readonly, copy, nonatomic) NSString *persistentStoreIdentifier;
@property (readonly, assign, nonatomic) pid_t senderProcessIdentifier;

@end

@interface NSManagedObjectContext (EMBPersistentStoreNotification)

+ (EMBPersistentStoreNotification *)createPersistentStoreNotificationFromChangeNotification:(NSNotification *)notification persistentStoreIdentifier:(NSString *)persistentStoreIdentifier;

- (NSNotification *)createChangeNotificationFromPersistentStoreNotification:(EMBPersistentStoreNotification *)notification;
- (void)mergeChangesFromPersistentStoreNotification:(EMBPersistentStoreNotification *)notification;

@end
