//
//  EMBWebSnapCreationURLHandler.h
//  Ember
//
//  Created by Damien DeVille on 19/04/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

extern NSString * const EMBWebsnapCreationURLHandlerURLKey;
extern NSString * const EMBWebsnapCreationURLHandlerBookmarkOnlyKey;
extern NSString * const EMBWebsnapCreationURLHandlerWidthKey;
extern NSString * const EMBWebsnapCreationURLHandlerCookiesKey;
extern NSString * const EMBWebsnapCreationURLHandlerTitleKey;
extern NSString * const EMBWebsnapCreationURLHandlerDescriptionKey;
extern NSString * const EMBWebsnapCreationURLHandlerRatingKey;
extern NSString * const EMBWebsnapCreationURLHandlerTagsKey;
extern NSString * const EMBWebsnapCreationURLHandlerCollectionsKey;
extern NSString * const EMBWebsnapCreationURLHandlerExtensionBundleIDKey;
extern NSString * const EMBWebsnapCreationURLHandlerExtensionBuildNumberKey;

extern NSString * const EMBWebSnapOperationPageURLKey;
extern NSString * const EMBWebSnapOperationPageWidthKey;
extern NSString * const EMBWebSnapOperationPageCookiesKey;
extern NSString * const EMBWebSnapOperationBookmarkOnlyKey;
extern NSString * const EMBWebSnapOperationSnapMetadataKey;
extern NSString * const EMBWebSnapOperationExtensionBundleIDKey;
extern NSString * const EMBWebSnapOperationExtensionBuildNumberKey;

@interface EMBWebSnapCreationURLHandler : NSObject

/*!
	\brief
	Parameters are read from the URL query
 */
+ (NSDictionary *)webSnapTaskOperationOptionsDictionaryForURL:(NSURL *)url error:(NSError **)errorRef;

/*!
	\brief
	Content-Type should be application/x-www-form-urlencoded
 */
+ (NSDictionary *)webSnapTaskOperationOptionsDictionaryForRequest:(NSURLRequest *)request error:(NSError **)errorRef;

@end
