//
// Copyright (C) 2008-2012 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.
//

#import <TargetConditionals.h>

#import <CoreData/CoreData.h>

#import "EMBEmberHelpers/EMBEmberHelpers.h"

extern NSString * const EMBSubscriptionEntityName;

@class EMBSubscriptionItem;

@interface EMBSubscription : NSManagedObject

+ (EMBSubscription *)createSubscriptionInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext persistentStore:(NSPersistentStore *)persistentStore title:(NSString *)title feedURL:(NSURL *)feedURL;

extern NSString * const EMBSubscriptionTitleKey;
@property (copy, nonatomic) NSString *title;

extern NSString * const EMBSubscriptionIdentifierKey;
@property (copy, nonatomic) NSString *identifier;

extern NSString * const EMBSubscriptionOrderKey;
@property (strong, nonatomic) NSNumber *order;

extern NSString * const EMBSubscriptionFeedURLKey;
extern NSString * const EMBSubscriptionFeedURLAttributeName;
@property (copy, nonatomic) NSURL *feedURL;
- (NSURL *)requireFeedURL:(NSError **)errorRef;

extern NSString * const EMBSubscriptionIconRelativePathKey;
@property (copy, nonatomic) NSString *iconRelativePath;

extern NSString * const EMBSubscriptionLastRefreshDateKey;
@property (strong, nonatomic) NSDate *lastRefreshDate;

extern NSString * const EMBSubscriptionEditableKey;
@property (assign, getter = isEditable, nonatomic) BOOL editable;

extern NSString * const EMBSubscriptionRefreshingKey;
@property (assign, getter = isRefreshing, nonatomic) BOOL refreshing;

extern NSString * const EMBSubscriptionUnreadCountKey;
@property (readonly, assign, nonatomic) NSUInteger unreadCount;

extern NSString * const EMBSubscriptionLastSeenSubscriptionItemURIRepresentationKey;
@property (strong, nonatomic) NSString *lastSeenSubscriptionItemURIRepresentation;

- (void)setLastSeenSubscriptionItem:(EMBSubscriptionItem *)lastSeenSubscriptionItem;
- (EMBSubscriptionItem *)lastSeenSubscriptionItemInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;
- (EMBSubscriptionItem *)firstUnreadSubscriptionItemInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;

+ (NSFetchRequest *)fetchRequestWithManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;

#if TARGET_OS_IPHONE
+ (NSFetchedResultsController *)fetchedResultsControllerInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;
#endif

@end
