//
// Copyright (C) 2008-2011 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.
//

#import <TargetConditionals.h>
#import <Foundation/Foundation.h>

#if TARGET_OS_IPHONE
#import <UIKit/UIKit.h>
#else
#import <AppKit/AppKit.h>
#endif /* TARGET_OS_IPHONE */

#if TARGET_OS_IPHONE

@compatibility_alias EMBPortableImage UIImage;

@interface EMBPortableImage (PortableAdditions)

- (id)initWithCGImage:(CGImageRef)image size:(CGSize)size;

- (id)initWithContentsOfURL:(NSURL *)imageURL;
- (id)initByReferencingURL:(NSURL *)imageURL;	// This behaves differently to the AppKit version, and does immediately load the image.

@end

#else

@compatibility_alias EMBPortableImage NSImage;

#endif /* TARGET_OS_IPHONE */
