//
//  Ember-Defaults.h
//  Ember
//
//  Created by Damien DeVille on 05/05/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <TargetConditionals.h>
#import <Foundation/Foundation.h>

// Annotations
extern NSString * const EMBEmberAnnotationsCurrentToolDefaultKey;
extern NSString * const EMBEmberAnnotationsColorDefaultKey;
extern NSString * const EMBEmberAnnotationsLineWidthDefaultKey;

// Import
extern NSString * const EMBImportAutoTagDefaultKey;
extern NSString * const EMBImportSnapTypeDefaultKey;	// stored as EMBSnapObjectType

// Export
typedef NS_ENUM(NSUInteger, EMBExportFileType) {
	EMBExportFileTypePNG = 0,
	EMBExportFileTypeJPEG = 1,
	EMBExportFileTypeDocument = 2,
	EMBExportFileTypePDF = 3,
	EMBExportFileTypeOriginalFormat = 4,
};

extern NSString * const EMBExportFileTypeDefaultKey;	// stored as EMBExportFileType

extern NSString * const EMBExportIncludeAnnotationsDefaultKey;
extern NSString * const EMBExportIncludeTagsDefaultKey;

typedef NS_ENUM(NSUInteger, EMBExportScalingType) {
	EMBExportScalingTypeOriginal = 0,
	EMBExportScalingTypeSize = 1,
	EMBExportScalingTypeScale = 2,
};

typedef NS_ENUM(NSUInteger, EMBEmberPreferenceSortOrder) {
	EMBEmberPreferenceSortReverseChronological = 0,
	EMBEmberPreferenceSortChronological = 1,
	EMBEmberPreferenceSortAlphabetical = 2,
	EMBEmberPreferenceSortReverseAlphabetical = 3,
};

extern NSString * const EMBExportCopyURLAfterPublishingDefaultKey;

extern NSString * const EMBEmberPreferenceGallerySortOrderIntegerKey;	// stored as EMBEmberPreferenceSortOrder

typedef NS_ENUM(NSInteger, EMBEmberLibraryLocation) {
	EMBEmberLibraryLocationLocal = 0,
	EMBEmberLibraryLocationCloud = 1,
	EMBEmberLibraryLocationDropbox = 2,
};

// Library
extern NSString * const EMBEmberLibraryUseUbiquitousDefaultKey;	// DEPRECATED
extern NSString * const EMBEmberLibraryLocationDefaultKey;	// stored as EMBEmberLibraryLocation

#if !TARGET_OS_IPHONE

typedef NS_OPTIONS(NSUInteger, EMBEmberPreferenceGalleryCellDisplayOption) {
	EMBEmberPreferenceGalleryCellDisplayOptionNone = 0,
	EMBEmberPreferenceGalleryCellDisplayOptionName = 1U << 0,
	EMBEmberPreferenceGalleryCellDisplayOptionDate = 1U << 1,
};

extern NSString * const EMBEmberPreferenceGalleryCellDisplayOptionDefaultKey;	// stored as EMBEmberPreferenceGalleryCellDisplayOption
extern NSString * const EMBEmberPreferenceGalleryCellDisplayBackgroundPatternDefaultKey;

// Key combos
extern NSString * const EMBSnapDesktopKeyComboDefaultKey;
extern NSString * const EMBSnapTimedDesktopKeyComboDefaultKey;
extern NSString * const EMBSnapAreaKeyComboDefaultKey;
extern NSString * const EMBSnapWindowKeyComboDefaultKey;
extern NSString * const EMBRecordAreaKeyComboDefaultKey;
extern NSString * const EMBSnapCurrentBrowserURLKeyComboDefaultKey;
extern NSString * const EMBOpenCurrentBrowserURLInEmberKeyComboDefaultKey;
extern NSString * const EMBShowEmberKeyComboDefaultKey;

// Sounds
extern NSString * const EMBEmberSoundsEnabledDefaultKey;

typedef NS_ENUM(NSInteger, EMBEmberIntroductionStep) {
	EMBEmberIntroductionStepWelcome = 0,
	EMBEmberIntroductionStepLibraryLocationSelection = 1,
	EMBEmberIntroductionStepBrowserExtensions = 2,
	EMBEmberIntroductionStepLittleSnapperImport = 3,
	
	EMBEmberIntroductionStep10Complete = 5,	// complete introduction as per 1.0
};

extern NSString * const EMBEmberIntroductionStepDefaultKey;	// stored as EMBEmberIntroductionStep

// Color search
extern NSString * const EMBEmberColorSearchToleranceDefaultKey;	// stored as EMBEmberColorSearchTolerance

// Snapping
typedef NS_ENUM(NSUInteger, EMBPostSnappingAction) {
	EMBPostSnappingDoNothing = 0,
	EMBPostSnappingShowLibrary = 1,
	EMBPostSnappingEditSnap = 2,
	EMBPostSnappingEditMetadata = 3,
};
extern NSString * const EMBPostSnappingActionDefaultKey;	// stored as EMBPostSnappingAction
extern NSString * const EMBPostSnappingActionCopyToClipboardDefaultKey;

extern NSString * const EMBCaptureDropShadowDefaultKey;
extern NSString * const EMBCaptureCursorDefaultKey;
extern NSString * const EMBHideMainWindowWhenSnappingDefaultKey;
extern NSString * const EMBLastSnapAreaRectKey;

// Agents
typedef NS_ENUM(NSUInteger, EMBEmberStatusItemStateType) {
	EMBEmberStatusItemStateHidden = 0,
	EMBEmberStatusItemStateShowEmberIsRunning = 1,
	EMBEmberStatusItemStateShowAllTheTime = 2,
};

extern NSString * const EMBQuitLibraryMediatorAtTerminationDefaultKey;
extern NSString * const EMBEmberStatusItemStateTypeDefaultKey;	// stored as EMBEmberStatusItemStateType

// Editors
extern NSString * const EMBEmberViewSourceApplicationBundleIdentifierDefaultKey;
extern NSString * const EMBEmberEditImageApplicationBundleIdentifierDefaultKey;

// Inspector
extern NSString * const EMBSnapsViewControllerInspectorVisibleDefaultKey;

extern NSString * const EMBInspectorDescriptionTextViewContinuousSpellCheckingEnabledDefaultKey;
extern NSString * const EMBInspectorDescriptionTextViewGrammarCheckingEnabledDefaultKey;
extern NSString * const EMBInspectorDescriptionTextViewAutomaticSpellingCorrectionEnabledDefaultKey;

extern NSString * const EMBInspectorDescriptionTextViewSmartInsertDeleteEnabledDefaultKey;
extern NSString * const EMBInspectorDescriptionTextViewAutomaticQuoteSubstitutionEnabledDefaultKey;
extern NSString * const EMBInspectorDescriptionTextViewAutomaticDashSubstitutionEnabledDefaultKey;
extern NSString * const EMBInspectorDescriptionTextViewAutomaticLinkDetectionEnabledDefaultKey;
extern NSString * const EMBInspectorDescriptionTextViewAutomaticDataDetectionEnabledDefaultKey;
extern NSString * const EMBInspectorDescriptionTextViewAutomaticTextReplacementEnabledDefaultKey;

// Tags
extern NSString * const EMBEmberTagsWindowVisibleAtLaunchDefaultKey;
extern NSString * const EMBEmberTagsWindowSortOrderDefaultKey;

typedef NS_ENUM(NSUInteger, EMBEmberTagsWindowSortOrder) {
	EMBEmberTagsWindowSortOrderAlphabetical = 0,
	EMBEmberTagsWindowSortOrderReverseAlphabetical = 1,
	EMBEmberTagsWindowSortOrderCountAscending = 2,
	EMBEmberTagsWindowSortOrderCountDescending = 3,
};

#endif /* !TARGET_OS_IPHONE */

#if TARGET_OS_IPHONE

extern NSString * const EMBEmberPreferenceDidChangeNotification;
	extern NSString * const EMBEmberPreferenceDidChangePreferenceKey;
	extern NSString * const EMBEmberPreferenceDidChangeValueKey;

extern NSString * const EMBEmberImagePickerImageWriteToSavedPhotosAlbumKey;
extern NSString * const EMBEmberImportScreenshotsAutoImportKey;

extern NSString * const EMBEmberTouchIntroductionShownDefaultKey;
extern NSString * const EMBEmberTouchNewFeaturesVersionShownDefaultKey;

#endif /* TARGET_OS_IPHONE */
