//
//  Ember-Functions.h
//  Ember
//
//  Created by Damien DeVille on 05/05/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <TargetConditionals.h>
#import <Foundation/Foundation.h>
#if TARGET_OS_IPHONE
#import <UIKit/UIKit.h>
#import <CoreGraphics/CoreGraphics.h>
#endif

// Locations
extern NSURL *EMBLibraryFolderLocation(void);
extern NSURL *EMBApplicationSupportFolderLocation(void);
extern NSURL *EMBDocumentsFolderLocation(void);
extern NSURL *EMBTemporaryFolderLocation(void);

extern NSURL *EMBApplicationSupportEmberFolderLocation(void);

extern NSURL *EMBEmberLibraryFolderLocation(void);
extern NSURL *EMBEmberLibraryUbiquityFolderLocation(void);

extern NSURL *EMBEmberSubscriptionImagesFolderLocation(void);

extern NSURL *EMBEmberLittleSnapperImportedLibrariesFolderLocation(void);


// Random name
extern NSString *EMBCreateUniqueFileName(void);

// Snap name
extern NSString *EMBCreateUniqueSnapFileName(void);

// Thumbnail name
extern NSString *EMBCreateUniqueThumbnailFileName(void);


// File type
extern NSString *EMBRetrieveURLTypeIdentifier(NSURL *fileURL, NSError **errorRef);
extern BOOL EMBIsFileTypeSupported(NSURL *fileLocation);
extern BOOL EMBIsFileImage(NSURL *fileLocation);
extern BOOL EMBIsFilePDF(NSURL *fileLocation);
extern BOOL EMBIsFileMovie(NSURL *fileLocation);
extern BOOL EMBIsFileText(NSURL *fileLocation);
extern BOOL EMBIsFileWebMedia(NSURL *fileLocation);
extern BOOL EMBIsFileSnapBundle(NSURL *fileLocation);
extern BOOL EMBIsFileEmberSnap(NSURL *fileLocation);
extern BOOL EMBIsFileLittleSnapperLibrary(NSURL *fileLocation);

extern NSArray *EMBEmberMacSupportedFileTypes(void);

// Paths
extern NSString *EMBRelativePathForAbsoluteURL(NSURL *baseURL, NSURL *URL);
extern NSURL *EMBAbsoluteURLForPath(NSURL *baseURL, NSString *path);


// Saving item image paths
extern NSString *EMBItemAddExtension(NSString *title, NSString *UTI);
extern NSURL *EMBItemSavingImageURL(NSURL *absoluteURL, NSString *title, NSString *UTI);
extern NSURL *EMBItemSavingSmallImageURL(NSURL *absoluteURL, NSString *title, NSString *UTI);
extern NSURL *EMBItemSavingThumbnailURL(NSURL *absoluteURL, NSString *title, NSString *UTI);


// Image sizes
extern BOOL EMBIsSnapSizeAniOSScreenShot(CGSize size);
extern BOOL EMBIsSnapSizeAniPhoneScreenShot(CGSize size);
extern BOOL EMBIsSnapSizeAniPadScreenShot(CGSize size);


// Image orientation
#if TARGET_OS_IPHONE
extern UIImageOrientation EMBImageOrientationFromEXIFTag(NSInteger tag);
#endif /* TARGET_OS_IPHONE */


// Email validation
extern BOOL EMBIsValidEmail(NSString *email);
