//
//  EMBSnapsController.h
//  EmberCommon
//
//  Created by Damien DeVille on 20/11/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "EMBEmberKit/EMBEmberLibraryPresenter.h"

@class NSManagedObjectContext;
@class EMBEmberLibrary;

@interface EMBSnapsController : NSObject <EMBEmberLibraryPresenter>

@property (readonly, strong, nonatomic) NSOperationQueue *deletionQueue;

- (void)deleteSnapsWithObjectIdentifiers:(NSArray *)snaps;
- (void)cleanupScheduledForDeletionSnaps;

@property (readonly, strong, nonatomic) NSOperationQueue *colourAnalysisQueue;

- (void)performSnapColourAnalysisIfNeeded;

@end

extern NSString * const EMBSnapsControllerWillMergeCriticalChangesNotification;
extern NSString * const EMBSnapsControllerDidMergeCriticalChangesNotification;
