//
//  EMBSubscriptionsManager.h
//  EmberCommon
//
//  Created by Damien DeVille on 07/11/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

@class NSManagedObjectID, NSManagedObjectContext;
@class EMBEmberLibrary, EMBSubscription;

@interface EMBSubscriptionsManager : NSObject

@property (assign, nonatomic) NSTimeInterval refreshInterval;

@property (readonly, strong, nonatomic) NSOperationQueue *refreshOperationQueue;

- (BOOL)shouldRefreshSubscription:(EMBSubscription *)subscription managedObjectContext:(NSManagedObjectContext *)managedObjectContext;

- (void)refreshSubscription:(NSManagedObjectID *)subscriptionObjectID managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;
- (void)refreshSubscriptions:(NSArray *)subscriptionObjectIDs managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;

- (void)markSubscriptionItemsInSubscriptionsAsRead:(NSArray *)subscriptionObjectIDs managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;

- (void)cancelRefreshForSubscription:(NSManagedObjectID *)subscriptionObjectID;

- (void)deleteItemsForSubscriptionURIRepresentation:(NSURL *)subscriptionURIRepresentation beforeDate:(NSDate *)date managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;

@end

extern NSString * const EMBSubscriptionsManagerWillRefreshSubscriptionsNotification;
extern NSString * const EMBSubscriptionsManagerDidRefreshSubscriptionsNotification;
	extern NSString * const EMBSubscriptionsManagerRefreshingSubscriptionObjectIDsKey;	// NSArray
	extern NSString * const EMBSubscriptionsManagerRefreshingSubscriptionItemsObjectIDsKey;	// NSArray of NSArray

extern NSString * const EMBSubscriptionsManagerDidDeleteItemsNotification;
	extern NSString * const EMBSubscriptionsManagerDeletedItemsSubscriptionURIRepresentation;
