//
//  EMBEmberOperations.h
//  EMBEmberOperations
//
//  Created by Damien DeVille on 21/09/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <TargetConditionals.h>

#import <Foundation/Foundation.h>

#import "EMBEmberOperations/EMBEmberOperations-Constants.h"

/*
	Task
 */
#import "EMBEmberOperations/EMBEmberTask.h"

/*
	Import
 */
#import "EMBEmberOperations/EMBImportOperation.h"
#import "EMBEmberOperations/EMBBatchImportOperation.h"
#import "EMBEmberOperations/EMBImageImportOperation.h"
#import "EMBEmberOperations/EMBVisualMediaImportOperation.h"
#import "EMBEmberOperations/EMBPDFImportOperation.h"
#import "EMBEmberOperations/EMBMovieImportOperation.h"
#import "EMBEmberOperations/EMBTextImportOperation.h"
#import "EMBEmberOperations/EMBWebMediaImportOperation.h"
#if !TARGET_OS_IPHONE
#import "EMBEmberOperations/EMBWebSnapImportOperation.h"
#import "EMBEmberOperations/EMBSnapBundleImportOperation.h"
#endif /* !TARGET_OS_IPHONE */
#import "EMBEmberOperations/EMBSnapDocumentImportOperation.h"
#import "EMBEmberOperations/EMBImageDownloadImportOperation.h"
#if TARGET_OS_IPHONE
#import "EMBEmberOperations/EMBAssetsLibraryAssetRetrievalOperation.h"
#endif /* TARGET_OS_IPHONE */

/*
	Export
 */
#import "EMBEmberOperations/EMBSnapBatchExportOperation.h"
#import "EMBEmberOperations/EMBSnapImageExportOperation.h"
#import "EMBEmberOperations/EMBSnapDocumentExportOperation.h"
#import "EMBEmberOperations/EMBSnapDocumentUpdateOperation.h"
#import "EMBEmberOperations/EMBSnapOriginalFormatExportOperation.h"
#if !TARGET_OS_IPHONE
#import "EMBEmberOperations/EMBSnapPDFExportOperation.h"
#import "EMBEmberOperations/EMBSnapPrintExportOperation.h"
#endif /* !TARGET_OS_IPHONE */

/*
	Thumbnails
 */
#import "EMBEmberOperations/EMBSnapCompositedImageRefreshOperation.h"
#import "EMBEmberOperations/EMBSnapThumbnailRefreshOperation.h"
#import "EMBEmberOperations/EMBSubscriptionThumbnailRefreshOperation.h"
#import "EMBEmberOperations/EMBThumbnailGenerationOperation.h"
#import "EMBEmberOperations/EMBThumbnailImageCoordinatedCreationOperation.h"

/*
	Deletion
 */
#import "EMBEmberOperations/EMBSnapDeletionOperation.h"
#import "EMBEmberOperations/EMBSubscriptionItemDeletionOperation.h"

/*
	Migration
 */
#import "EMBEmberOperations/EMBEmberLibraryMigrationOperation.h"
#import "EMBEmberOperations/EMBEmberLibraryResetOperation.h"

/*
	Snapping
 */
#if !TARGET_OS_IPHONE
#import "EMBEmberOperations/EMBScreenSnapOperation.h"
#import "EMBEmberOperations/EMBBatchScreenSnapOperation.h"
#import "EMBEmberOperations/EMBWebSnapOperation.h"
#import "EMBEmberOperations/EMBWebArchiveSnapOperation.h"
#endif /* !TARGET_OS_IPHONE */

/*
	Subscriptions
 */
#import "EMBEmberOperations/EMBSubscriptionRefreshOperation.h"
#import "EMBEmberOperations/EMBBatchSubscriptionRefreshOperation.h"
#import "EMBEmberOperations/EMBSubscriptionCleanupOperation.h"
#import "EMBEmberOperations/EMBSubscriptionItemImportOperation.h"

/*
	Little Snapper import
 */
#if !TARGET_OS_IPHONE
#import "EMBEmberOperations/EMBLittleSnapperLibraryFindOperation.h"
#import "EMBEmberOperations/EMBLittleSnapperLibraryImportOperation.h"
#endif /* #if !TARGET_OS_IPHONE */

/*
	Colour analysis
 */
#import "EMBEmberOperations/EMBBatchSnapColourAnalysisOperation.h"
#import "EMBEmberOperations/EMBSnapColourAnalysisOperation.h"

/*
	Backup
 */
#import "EMBEmberOperations/EMBEmberLibraryBackupOperation.h"
#import "EMBEmberOperations/EMBEmberLibraryMetadataBackupOperation.h"
#import "EMBEmberOperations/EMBEmberLibraryRestoreBackupOperation.h"
