//
//  EMBImportOperation.h
//  EmberTouch
//
//  Created by Damien DeVille on 30/05/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

@class NSManagedObjectContext, NSManagedObjectID;
@class EMBEmberLibrary;

@interface EMBImportOperation : EMBConcurrentOperation <EMBProgressOperation>

+ (id)importOperationWithAssetURL:(NSURL *)assetURL managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;

@property (readonly, strong, nonatomic) NSManagedObjectContext *managedObjectContext;
@property (readonly, strong, nonatomic) EMBEmberLibrary *emberLibrary;

@property (readonly, copy, nonatomic) NSURL *assetURL;

@property (readonly, copy, atomic) NSManagedObjectID * (^completionProvider)(NSError **errorRef);

@end

@interface EMBImportOperation (/* Import customization */)

@property (strong, nonatomic) NSDictionary *snapMetadata;
@property (assign, nonatomic) BOOL replaceExistingItem;

@end
