//
// Copyright (C) 2008-2012 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.
//

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

@class NSManagedObjectContext, NSManagedObjectID;
@class EMBEmberLibrary;

@protocol EMBSnapColourAnalysisOperationSnapObjectIDCompletionProvider <NSObject>

@property (readonly, atomic) NSManagedObjectID * (^completionProvider)(NSError **);

@end

@interface EMBSnapColourAnalysisOperation : EMBConcurrentOperation <EMBProgressOperation>

- (id)initWithSnapObjectID:(NSManagedObjectID *)snapObjectID managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;

- (id)initWithSnapObjectIDProvider:(NSOperation <EMBSnapColourAnalysisOperationSnapObjectIDCompletionProvider> *)snapObjectIDProvider managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;

/*
	Note:
	
	We attempt to retrieve the snap from the working managed object context in a safe way so that in case it
	has been deleted in the meantime we will not result in a fault failing to be fulfilled.
	However, in case the snap object ID is temporary (such as performing this operation before the snap has been saved to disk)
	this method will not be able to return the snap.
	In this case, setting this property to YES will attempt to retrieve the snap in an unsafe manner which should be safe in this very case.
 */
@property (assign, getter = isSnapObjectIDTemporary, nonatomic) BOOL snapObjectIDTemporary;

@property (readonly, copy, atomic) NSManagedObjectID * (^completionProvider)(NSError **errorRef);

@end
