//
//  EMBSnapOriginalFormatExportOperation.h
//  EmberCommon
//
//  Created by Damien DeVille on 5/23/14.
//  Copyright (c) 2014 Realmac Software. All rights reserved.
//

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"
#import "EMBEmberOperations/EMBSnapImageExportOperation.h"

@class NSManagedObjectID, NSManagedObjectContext;
@class EMBEmberLibrary;

@interface EMBSnapOriginalFormatExportOperation : EMBConcurrentOperation <EMBProgressOperation>

- (id)initWithSnapObjectID:(NSManagedObjectID *)snapObjectID managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary exportLocation:(NSURL *)exportLocation exportFilename:(NSString *)exportFilename exportOptions:(NSDictionary *)exportOptions;
- (id)initWithSnapObjectIDProvider:(NSOperation <EMBSnapImageExportOperationSnapObjectIDProvider> *)snapObjectIDProvider managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary exportLocationProvider:(NSOperation <EMBSnapImageExportOperationExportLocationProvider> *)exportLocationProvider exportFilenameProvider:(NSOperation <EMBSnapImageExportOperationExportFilenameProvider> *)exportFilenameProvider exportOptionsProvider:(NSOperation <EMBSnapImageExportOperationExportOptionsProvider> *)exportOptionsProvider;

@property (readonly, copy, atomic) NSURL * (^completionProvider)(NSError **errorRef);

@end
